FUNCTION SelectFolder(STRING FolderType,STRING Prompt,OUTPUT STRING Result) {
   $Result=''
   STRING LIST ValidFolderNames={'ncprogram','toolpath','tool','boundary','pattern','featureset','featuregroup','workplane','model','stockmodel'}
   IF not member($ValidFolderNames,lcase($FolderType)) {
      MESSAGE ERROR 'Invalid Name!'
      RETURN
   }
   STRING LIST Folders = get_folders($FolderType)
   IF (size($Folders) == 0) {
      RETURN
   }
   $Folders=reverse($Folders)
   STRING LIST F=tokens($Folders[0],'\')
   STRING $cmd='EXPLORER SELECT $F[0] ROOT'
   DoCommand $cmd
   DEBUG EXPLORER KEY RIGHT_RECURSIVE
   FOREACH ff in folders {
      EXPLORER SELECT FOLDER $FF NEW
      DEBUG EXPLORER KEY LEFT
   }
   $Folders=reverse($Folders)
   
   STRING LIST ShortNames={}
   INT I=length($FolderType)+1
   STRING Space='........................'
   FOREACH item in $Folders {
      $F=tokens($item,'\')
      INT S=size($f)
      IF $S >12 {
         MESSAGE INFO ' Sorry, only 12 sublevlel handled'
         RETURN
      }
      IF $S >2 {
         $F[1]=substring($Space,0,2*($S-2))+$F[size($F)-1]
      }
      INT J= add_last($ShortNames,$F[1])
   }
   INT C=-1
   $C=INPUT CHOICE $ShortNames $Prompt
   IF $C != -1 {
      $Result=$Folders[$C]
      $F=tokens($Folders[$C],'\')
      STRING N=$F[0]
      $i=1
      DO {
         $N=$N+'\'+$F[$i]
         EXPLORER SELECT FOLDER $N NEW
         DEBUG EXPLORER KEY RIGHT
         $i=$i+1
      } WHILE $i < size($F)
      ACTIVATE FOLDER $N
   }
}

